test-lib: verbose mode for only tests matching a pattern
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
29e55cd5
JH
95GIT_AUTHOR_EMAIL=author@example.com
96GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
97GIT_COMMITTER_EMAIL=committer@example.com
98GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 99GIT_MERGE_VERBOSITY=5
f8246281
JH
100GIT_MERGE_AUTOEDIT=no
101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 104export EDITOR
e1970ce4 105
a731fa91
EP
106# Add libc MALLOC and MALLOC_PERTURB test
107# only if we are not executing the test with valgrind
1b3185fc 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 109 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
110then
111 setup_malloc_check () {
112 : nothing
113 }
114 teardown_malloc_check () {
115 : nothing
116 }
117else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
121 }
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
124 }
125fi
a731fa91 126
886a3907
JH
127# Protect ourselves from common misconfiguration to export
128# CDPATH into the environment
129unset CDPATH
130
5565f47c 131unset GREP_OPTIONS
ac001282 132unset UNZIP
5565f47c 133
3d5c0cc9 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1351|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
140 ;;
6ce4e61f
CC
141esac
142
cd3c095c
JH
143# Convenience
144#
145# A regexp to match 5 and 40 hexdigits
146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
148
3749fde5
JH
149# Zero SHA-1
150_z40=0000000000000000000000000000000000000000
151
3f4ab627
JH
152# Line feed
153LF='
154'
155
342e9ef2
TR
156export _x05 _x40 _z40 LF
157
e1970ce4
JH
158# Each test should start with something like this, after copyright notices:
159#
160# test_description='Description of this test...
161# This test checks if command xyzzy does the right thing...
162# '
163# . ./test-lib.sh
c2116a17
JH
164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
55db1df0 172 color=t
e1970ce4 173
e1970ce4
JH
174while test "$#" -ne 0
175do
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
886856ab
JH
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
5e2c08c6 181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 183 -h|--h|--he|--hel|--help)
570f3226 184 help=t; shift ;;
e1970ce4
JH
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
ff09af3f
TR
187 --verbose-only=*)
188 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
189 shift ;;
1ece1274 190 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
191 # Ignore --quiet under a TAP::Harness. Saying how many tests
192 # passed without the ok/not ok details is always an error.
193 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
194 --with-dashes)
195 with_dashes=t; shift ;;
55db1df0 196 --no-color)
faa4bc35 197 color=; shift ;;
4e1be63c 198 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
199 valgrind=memcheck
200 shift ;;
201 --valgrind=*)
202 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
203 shift ;;
44138559
JS
204 --tee)
205 shift ;; # was handled already
f423ef5f
JK
206 --root=*)
207 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
208 shift ;;
e1970ce4 209 *)
1f729dca 210 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
211 esac
212done
213
952af351
TR
214test -n "$valgrind" && verbose=t
215
1c0cc756
RJ
216if test -n "$color"
217then
55db1df0 218 say_color () {
c2116a17
JH
219 (
220 TERM=$ORIGINAL_TERM
221 export TERM
55db1df0 222 case "$1" in
1c0cc756
RJ
223 error)
224 tput bold; tput setaf 1;; # bold red
225 skip)
b8fc855a 226 tput setaf 4;; # blue
e8e51955
AS
227 warn)
228 tput setaf 3;; # brown/yellow
1c0cc756 229 pass)
0a6d4751 230 tput setaf 2;; # green
1c0cc756 231 info)
0a6d4751 232 tput setaf 6;; # cyan
1c0cc756
RJ
233 *)
234 test -n "$quiet" && return;;
55db1df0
PH
235 esac
236 shift
5099b99d 237 printf "%s" "$*"
55db1df0 238 tput sgr0
b8eecafd 239 echo
c2116a17 240 )
55db1df0
PH
241 }
242else
243 say_color() {
1ece1274 244 test -z "$1" && test -n "$quiet" && return
55db1df0 245 shift
7bc0911d 246 printf "%s\n" "$*"
55db1df0
PH
247 }
248fi
249
250error () {
251 say_color error "error: $*"
6e7b5aaf 252 GIT_EXIT_OK=t
55db1df0
PH
253 exit 1
254}
255
256say () {
257 say_color info "$*"
258}
259
570f3226
MB
260test "${test_description}" != "" ||
261error "Test script did not set test_description."
262
263if test "$help" = "t"
264then
265 echo "$test_description"
266 exit 0
267fi
268
4d9d62fa 269exec 5>&1
781f76b1 270exec 6<&0
e1970ce4
JH
271if test "$verbose" = "t"
272then
273 exec 4>&2 3>&1
274else
275 exec 4>/dev/null 3>/dev/null
276fi
277
278test_failure=0
279test_count=0
41ac414e
JH
280test_fixed=0
281test_broken=0
2d84e9fb 282test_success=0
e1970ce4 283
d998bd4a
ÆAB
284test_external_has_tap=0
285
faa4bc35 286die () {
6e7b5aaf
CB
287 code=$?
288 if test -n "$GIT_EXIT_OK"
289 then
290 exit $code
291 else
292 echo >&5 "FATAL: Unexpected exit with code $code"
293 exit 1
294 fi
faa4bc35
CB
295}
296
6e7b5aaf 297GIT_EXIT_OK=
35641310 298trap 'die' EXIT
41184273 299
12a29b1a
TR
300# The user-facing functions are loaded from a separate file so that
301# test_perf subshells can have them too
3c8f12c9 302. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 303
886856ab
JH
304# You are not expected to call test_ok_ and test_failure_ directly, use
305# the text_expect_* functions instead.
306
307test_ok_ () {
d5d9de1b 308 test_success=$(($test_success + 1))
5099b99d 309 say_color "" "ok $test_count - $@"
e1970ce4
JH
310}
311
886856ab 312test_failure_ () {
d5d9de1b 313 test_failure=$(($test_failure + 1))
5e5c006e 314 say_color error "not ok $test_count - $1"
bf0dd8a8 315 shift
5099b99d 316 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 317 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
318}
319
41ac414e 320test_known_broken_ok_ () {
41ac414e 321 test_fixed=$(($test_fixed+1))
b73d9a23 322 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
323}
324
325test_known_broken_failure_ () {
41ac414e 326 test_broken=$(($test_broken+1))
e8e51955 327 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 328}
886856ab
JH
329
330test_debug () {
8e832ebc 331 test "$debug" = "" || eval "$1"
e1970ce4
JH
332}
333
e6a6ddc9
TR
334match_pattern_list () {
335 arg="$1"
336 shift
337 test -z "$*" && return 1
338 for pattern_
339 do
340 case "$arg" in
341 $pattern_)
342 return 0
343 esac
344 done
345 return 1
346}
347
ff09af3f
TR
348maybe_teardown_verbose () {
349 test -z "$verbose_only" && return
350 exec 4>/dev/null 3>/dev/null
351 verbose=
352}
353
354last_verbose=t
355maybe_setup_verbose () {
356 test -z "$verbose_only" && return
357 if match_pattern_list $test_count $verbose_only
358 then
359 exec 4>&2 3>&1
360 # Emit a delimiting blank line when going from
361 # non-verbose to verbose. Within verbose mode the
362 # delimiter is printed by test_expect_*. The choice
363 # of the initial $last_verbose is such that before
364 # test 1, we do not print it.
365 test -z "$last_verbose" && echo >&3 ""
366 verbose=t
367 else
368 exec 4>/dev/null 3>/dev/null
369 verbose=
370 fi
371 last_verbose=$verbose
372}
373
a7c58f28
JN
374test_eval_ () {
375 # This is a separate function because some tests use
376 # "return" to end a test_expect_success block early.
781f76b1 377 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
378}
379
4d9d62fa 380test_run_ () {
b6b0afdc 381 test_cleanup=:
b586744a 382 expecting_failure=$2
a57397b0 383 setup_malloc_check
a7c58f28 384 test_eval_ "$1"
b6b0afdc 385 eval_ret=$?
a57397b0 386 teardown_malloc_check
b586744a
JH
387
388 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
389 then
1b3185fc 390 setup_malloc_check
a7c58f28 391 test_eval_ "$test_cleanup"
1b3185fc 392 teardown_malloc_check
b586744a 393 fi
1c0cc756
RJ
394 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
395 then
57e1538a
ÆAB
396 echo ""
397 fi
aa0bcf96 398 return "$eval_ret"
4d9d62fa
PR
399}
400
ae75342c 401test_start_ () {
8586f98b 402 test_count=$(($test_count+1))
ff09af3f 403 maybe_setup_verbose
ae75342c
TR
404}
405
406test_finish_ () {
407 echo >&3 ""
ff09af3f 408 maybe_teardown_verbose
ae75342c
TR
409}
410
411test_skip () {
04ece593 412 to_skip=
e6a6ddc9
TR
413 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
414 then
415 to_skip=t
416 fi
05236a5e
JN
417 if test -z "$to_skip" && test -n "$test_prereq" &&
418 ! test_have_prereq "$test_prereq"
a7bb3940
JS
419 then
420 to_skip=t
421 fi
04ece593
JH
422 case "$to_skip" in
423 t)
07431fc8 424 of_prereq=
05236a5e 425 if test "$missing_prereq" != "$test_prereq"
07431fc8 426 then
05236a5e 427 of_prereq=" of $test_prereq"
07431fc8
JN
428 fi
429
55db1df0 430 say_color skip >&3 "skipping test: $@"
07431fc8 431 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
432 : true
433 ;;
434 *)
435 false
436 ;;
437 esac
438}
439
342e9ef2
TR
440# stub; perf-lib overrides it
441test_at_end_hook_ () {
442 :
443}
444
e1970ce4 445test_done () {
6e7b5aaf 446 GIT_EXIT_OK=t
2d84e9fb 447
517cd55f
TR
448 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
449 # output file
1c0cc756
RJ
450 if test -z "$HARNESS_ACTIVE"
451 then
342e9ef2 452 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 453 mkdir -p "$test_results_dir"
dd78478f
FC
454 base=${0##*/}
455 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 456
c54e6be7
ML
457 cat >>"$test_results_path" <<-EOF
458 total $test_count
459 success $test_success
460 fixed $test_fixed
461 broken $test_broken
462 failed $test_failure
463
464 EOF
8ef1abe5 465 fi
41ac414e
JH
466
467 if test "$test_fixed" != 0
468 then
b73d9a23 469 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
470 fi
471 if test "$test_broken" != 0
472 then
e8e51955 473 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
474 fi
475 if test "$test_broken" != 0 || test "$test_fixed" != 0
476 then
477 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
478 msg="remaining $test_remaining test(s)"
11d54b8b 479 else
b73d9a23 480 test_remaining=$test_count
11d54b8b 481 msg="$test_count test(s)"
41ac414e 482 fi
e1970ce4 483 case "$test_failure" in
10b94e28 484 0)
5099b99d 485 # Maybe print SKIP message
bf4b7219
RJ
486 if test -n "$skip_all" && test $test_count -gt 0
487 then
488 error "Can't use skip_all after running some tests"
489 fi
5099b99d
ÆAB
490 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
491
1c0cc756
RJ
492 if test $test_external_has_tap -eq 0
493 then
b73d9a23 494 if test $test_remaining -gt 0
d87bd7c1
RJ
495 then
496 say_color pass "# passed all $msg"
497 fi
d998bd4a
ÆAB
498 say "1..$test_count$skip_all"
499 fi
abc5d372
JS
500
501 test -d "$remove_trash" &&
502 cd "$(dirname "$remove_trash")" &&
503 rm -rf "$(basename "$remove_trash")"
504
342e9ef2
TR
505 test_at_end_hook_
506
e1970ce4
JH
507 exit 0 ;;
508
509 *)
1c0cc756
RJ
510 if test $test_external_has_tap -eq 0
511 then
d998bd4a
ÆAB
512 say_color error "# failed $test_failure among $msg"
513 say "1..$test_count"
514 fi
5099b99d 515
e1970ce4
JH
516 exit 1 ;;
517
518 esac
519}
520
e4597aae 521if test -n "$valgrind"
4e1be63c 522then
4e1be63c
JS
523 make_symlink () {
524 test -h "$2" &&
525 test "$1" = "$(readlink "$2")" || {
526 # be super paranoid
527 if mkdir "$2".lock
528 then
529 rm -f "$2" &&
530 ln -s "$1" "$2" &&
531 rm -r "$2".lock
532 else
533 while test -d "$2".lock
534 do
535 say "Waiting for lock on $2."
536 sleep 1
537 done
538 fi
539 }
540 }
541
542 make_valgrind_symlink () {
36bfb0e5
JK
543 # handle only executables, unless they are shell libraries that
544 # need to be in the exec-path. We will just use "#!" as a
545 # guess for a shell-script, since we have no idea what the user
546 # may have configured as the shell path.
547 test -x "$1" ||
548 test "#!" = "$(head -c 2 <"$1")" ||
549 return;
4e1be63c
JS
550
551 base=$(basename "$1")
6cec5c68 552 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
553 # do not override scripts
554 if test -x "$symlink_target" &&
555 test ! -d "$symlink_target" &&
556 test "#!" != "$(head -c 2 < "$symlink_target")"
557 then
558 symlink_target=../valgrind.sh
559 fi
efd92ffd
JS
560 case "$base" in
561 *.sh|*.perl)
562 symlink_target=../unprocessed-script
563 esac
4e1be63c
JS
564 # create the link, or replace it if it is out of date
565 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
566 }
567
568 # override all git executables in TEST_DIRECTORY/..
569 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
570 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 571 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
572 do
573 make_valgrind_symlink $file
574 done
ee0d7bf9
TR
575 # special-case the mergetools loadables
576 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
577 OLDIFS=$IFS
578 IFS=:
579 for path in $PATH
580 do
581 ls "$path"/git-* 2> /dev/null |
582 while read file
583 do
584 make_valgrind_symlink "$file"
585 done
586 done
587 IFS=$OLDIFS
4e1be63c
JS
588 PATH=$GIT_VALGRIND/bin:$PATH
589 GIT_EXEC_PATH=$GIT_VALGRIND/bin
590 export GIT_VALGRIND
952af351
TR
591 GIT_VALGRIND_MODE="$valgrind"
592 export GIT_VALGRIND_MODE
1c0cc756
RJ
593elif test -n "$GIT_TEST_INSTALLED"
594then
e4597aae
MO
595 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
596 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 597 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
598 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
599else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 600 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
601 if ! test -x "$git_bin_dir/git"
602 then
603 if test -z "$with_dashes"
604 then
e4597aae
MO
605 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
606 fi
607 with_dashes=t
608 fi
609 PATH="$git_bin_dir:$PATH"
6cec5c68 610 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
611 if test -n "$with_dashes"
612 then
6cec5c68 613 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 614 fi
4e1be63c 615fi
6cec5c68 616GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 617unset GIT_CONFIG
8bfa6bd6 618GIT_CONFIG_NOSYSTEM=1
3c995beb 619GIT_ATTR_NOSYSTEM=1
8f323c00 620export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 621
5e87eae9
JH
622if test -z "$GIT_TEST_CMP"
623then
624 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
625 then
626 GIT_TEST_CMP="$DIFF -c"
627 else
628 GIT_TEST_CMP="$DIFF -u"
629 fi
630fi
631
6cec5c68 632GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 633export GITPERLLIB
6cec5c68 634test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
635 error "You haven't built things yet, have you?"
636}
e1970ce4 637
ac10a857 638if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 639then
6cec5c68 640 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 641 export GITPYTHONLIB
6cec5c68 642 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
643 error "You haven't built git_remote_helpers yet, have you?"
644 }
645fi
646
1c0cc756
RJ
647if ! test -x "$GIT_BUILD_DIR"/test-chmtime
648then
56cf9806
EW
649 echo >&2 'You need to build test-chmtime:'
650 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
651 exit 1
652fi
653
e1970ce4 654# Test repository
002d4ce8
JK
655TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
656test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
657case "$TRASH_DIRECTORY" in
658/*) ;; # absolute path is good
659 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 660esac
91c8b825 661test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 662rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 663 GIT_EXIT_OK=t
8d14ac94
JH
664 echo >&5 "FATAL: Cannot prepare test area"
665 exit 1
666}
667
90cff968
AR
668HOME="$TRASH_DIRECTORY"
669export HOME
670
1c0cc756
RJ
671if test -z "$TEST_NO_CREATE_REPO"
672then
38b074de 673 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 674else
38b074de 675 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 676fi
1bd9c648
LW
677# Use -P to resolve symlinks in our working directory so that the cwd
678# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 679cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 680
d5d9de1b
JS
681this_test=${0##*/}
682this_test=${this_test%%-*}
e6a6ddc9
TR
683if match_pattern_list "$this_test" $GIT_SKIP_TESTS
684then
685 say_color info >&3 "skipping test $this_test altogether"
686 skip_all="skip all tests in $this_test"
687 test_done
688fi
f17e9fbb 689
8648732e
BC
690# Provide an implementation of the 'yes' utility
691yes () {
692 if test $# = 0
693 then
694 y=y
695 else
696 y="$*"
697 fi
698
699 while echo "$y"
700 do
701 :
702 done
703}
704
f17e9fbb
JS
705# Fix some commands on Windows
706case $(uname -s) in
707*MINGW*)
708 # Windows has its own (incompatible) sort and find
709 sort () {
710 /usr/bin/sort "$@"
711 }
712 find () {
713 /usr/bin/find "$@"
714 }
5397ea31
JS
715 sum () {
716 md5sum "$@"
717 }
4114156a
JS
718 # git sees Windows-style pwd
719 pwd () {
720 builtin pwd -W
721 }
ee9fb68c 722 # no POSIX permissions
6fd1106a 723 # backslashes in pathspec are converted to '/'
fb9a2bea 724 # exec does not inherit the PID
a94114ad 725 test_set_prereq MINGW
cfa96496 726 test_set_prereq NOT_CYGWIN
a31d0665
RJ
727 test_set_prereq SED_STRIPS_CR
728 ;;
729*CYGWIN*)
730 test_set_prereq POSIXPERM
a31d0665
RJ
731 test_set_prereq EXECKEEPSPID
732 test_set_prereq NOT_MINGW
cfa96496 733 test_set_prereq CYGWIN
a31d0665 734 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
735 ;;
736*)
737 test_set_prereq POSIXPERM
6fd1106a 738 test_set_prereq BSLASHPSPEC
fb9a2bea 739 test_set_prereq EXECKEEPSPID
3ba9ba8f 740 test_set_prereq NOT_MINGW
cfa96496 741 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
742 ;;
743esac
704a3143 744
b082687c 745( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 746test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 747test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 748test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 749test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 750
bb946bba 751# Can we rely on git's output in the C locale?
30955229
JN
752if test -n "$GETTEXT_POISON"
753then
754 GIT_GETTEXT_POISON=YesPlease
755 export GIT_GETTEXT_POISON
5e9637c6 756 test_set_prereq GETTEXT_POISON
30955229
JN
757else
758 test_set_prereq C_LOCALE_OUTPUT
759fi
bb946bba 760
cabdee2c
JH
761# Use this instead of test_cmp to compare files that contain expected and
762# actual output from git commands that can be translated. When running
763# under GETTEXT_POISON this pretends that the command produced expected
764# results.
765test_i18ncmp () {
766 test -n "$GETTEXT_POISON" || test_cmp "$@"
767}
768
127df8c6
JH
769# Use this instead of "grep expected-string actual" to see if the
770# output from a git command that can be translated either contains an
771# expected string, or does not contain an unwanted one. When running
772# under GETTEXT_POISON this pretends that the command produced expected
773# results.
774test_i18ngrep () {
775 if test -n "$GETTEXT_POISON"
776 then
777 : # pretend success
778 elif test "x!" = "x$1"
779 then
780 shift
781 ! grep "$@"
782 else
783 grep "$@"
784 fi
785}
786
20073274
AS
787test_lazy_prereq PIPE '
788 # test whether the filesystem supports FIFOs
789 rm -f testfifo && mkfifo testfifo
790'
791
04083f27
JH
792test_lazy_prereq SYMLINKS '
793 # test whether the filesystem supports symbolic links
794 ln -s x y && test -h y
795'
c91cfd19 796
ac39aa61
MG
797test_lazy_prereq CASE_INSENSITIVE_FS '
798 echo good >CamelCase &&
799 echo bad >camelcase &&
800 test "$(cat CamelCase)" != good
801'
802
5b0b5dd4
MG
803test_lazy_prereq UTF8_NFD_TO_NFC '
804 # check whether FS converts nfd unicode to nfc
805 auml=$(printf "\303\244")
806 aumlcdiar=$(printf "\141\314\210")
807 >"$auml" &&
808 case "$(echo *)" in
809 "$aumlcdiar")
810 true ;;
811 *)
812 false ;;
813 esac
814'
815
09feffb6
JK
816test_lazy_prereq AUTOIDENT '
817 sane_unset GIT_AUTHOR_NAME &&
818 sane_unset GIT_AUTHOR_EMAIL &&
819 git var GIT_AUTHOR_IDENT
820'
821
c91cfd19
ÆAB
822# When the tests are run as root, permission tests will report that
823# things are writable when they shouldn't be.
824test -w / || test_set_prereq SANITY
f838ce58
JK
825
826GIT_UNZIP=${GIT_UNZIP:-unzip}
827test_lazy_prereq UNZIP '
828 "$GIT_UNZIP" -v
829 test $? -ne 127
830'